<?php
/*
Plugin Name: Better tag cloud widget
Plugin URI: http://www.nkuttler.de/nktagcloud/
Author: Nicolas Kuttler
Author URI: http://www.nkuttler.de/
Description: Better tag cloud
Version: 0.1.0
*/

function nktagcloud_init() {
	register_sidebar_widget(__('Better tag cloud'), 'widget_nktagcloud');
	register_widget_control(   'Better tag cloud', 'nktagcloud_control', 300, 200 );
}
add_action('plugins_loaded', 'nktagcloud_init');

function widget_nktagcloud($args) {
	extract($args);
	echo $before_widget;
	echo $before_title;
	echo get_option('nktagcloud_title');
	echo $after_title;
	$smallest= get_option('nktagcloud_smallest');
	$largest= get_option('nktagcloud_largest');
	$unit= get_option('nktagcloud_unit');
	$number= get_option('nktagcloud_number');
	$format= get_option('nktagcloud_format');
	$order= get_option('nktagcloud_order');
	$orderby= get_option('nktagcloud_orderby');
    wp_tag_cloud("largest=$largest&smallest=$smallest&unit=$unit&number=$number&format=$format&order=$order&orderby=$orderby");
	if (!(get_option('nktagcloud_homelink') === 'Yes')) {
		add_action('wp_footer', 'nktagcloud_footer');
	}
	echo $after_widget;
}

// Install hook
register_activation_hook(__FILE__,'nktagcloud_install');
function nktagcould_install() {
	update_option('nktagcloud_title', 'Tags');
	update_option('nktagcloud_smallest', '8');
	update_option('nktagcloud_largest', '22');
	update_option('nktagcloud_unit', 'pt');
	update_option('nktagcloud_number', '0');
	update_option('nktagcloud_format', 'flat');
	update_option('nktagcloud_order', 'ASC');
	update_option('nktagcloud_orderby', 'name');
	update_option('nktagcloud_homelink', 'No');
}

function nktagcloud_control() {
	if ( $_POST['nktagcloud_title'] ) {
		if ($_POST['nktagcloud_title'] != get_option('nktagcloud_title') ) {
			update_option('nktagcloud_title', $_POST['nktagcloud_title']);
		}
		if ($_POST['nktagcloud_smallest'] != get_option('nktagcloud_smallest') ) {
			update_option('nktagcloud_smallest', $_POST['nktagcloud_smallest']);
		}
		if ($_POST['nktagcloud_largest'] != get_option('nktagcloud_largest') ) {
			update_option('nktagcloud_largest', $_POST['nktagcloud_largest']);
		}
		if ($_POST['nktagcloud_unit'] != get_option('nktagcloud_unit') ) {
			update_option('nktagcloud_unit', $_POST['nktagcloud_unit']);
		}
		if ($_POST['nktagcloud_number'] != get_option('nktagcloud_number') ) {
			if (!is_integer($_POST['nktagcloud_number'])) $_POST['nktagcloud_number'] = '0';
			update_option('nktagcloud_number', $_POST['nktagcloud_number']);
		}
		if ($_POST['nktagcloud_format'] != get_option('nktagcloud_format') ) {
			update_option('nktagcloud_format', $_POST['nktagcloud_format']);
		}
		if ($_POST['nktagcloud_order'] != get_option('nktagcloud_order') ) {
			update_option('nktagcloud_order', $_POST['nktagcloud_order']);
		}
		if ($_POST['nktagcloud_orderby'] != get_option('nktagcloud_orderby') ) {
			update_option('nktagcloud_orderby', $_POST['nktagcloud_orderby']);
		}
		if ($_POST['nktagcloud_homelink'] != get_option('nktagcloud_homelink') ) {
			update_option('nktagcloud_homelink', $_POST['nktagcloud_homelink']);
		}
	}
	?>
	<form action="" method="post">
		Please see <a href="http://codex.wordpress.org/Template_Tags/wp_tag_cloud" target="_blank">the wp_tag_cloud() page</a> for a description of the options.<br />
		Title
		<?php
			$select = get_option('nktagcloud_title'); 
		?>
		<input name="nktagcloud_title" type="text" size="15" value="<?php echo $select; ?>" />
		<br />
		Smallest font size?
		<select name="nktagcloud_smallest">
		<?php
			$select = get_option('nktagcloud_smallest'); 
			for ($i = 6 ; $i <= 40; $i++) {
				if ( $i == $select ) {
					echo "<option selected>$i</option>\n";
				}
				else {
					echo "<option>$i</option>\n";
				}
			}
		?>
		</select>
		<br />
		Largest font size?
		<select name="nktagcloud_largest">
		<?php
			$select = get_option('nktagcloud_largest'); 
			for ($i = 6 ; $i <= 40; $i++) {
				if ( $i == $select ) {
					echo "<option selected>$i</option>\n";
				}
				else {
					echo "<option>$i</option>\n";
				}
			}
		?>
		</select>
		<br />
		Unit
		<select name="nktagcloud_unit">
		<?php
			$choice = array('pt', 'px', '%', 'em', 'ex', 'mm', 'cm');
			$select = get_option('nktagcloud_unit'); 
			foreach ($choice as $unit) {
				if ( $unit == $select ) {
					echo "<option selected>$unit</option>\n";
				}
				else {
					echo "<option>$unit</option>\n";
				}
			}
		?>
		</select>
		<br />
		Number
		<?php
			$select = get_option('nktagcloud_number'); 
		?>
		<input name="nktagcloud_number" type="text" size="5" value="<?php echo $select; ?>" />
		<br />
		Format
		<select name="nktagcloud_format">
		<?php
			$choice = array('flat', 'list');
			$select = get_option('nktagcloud_format'); 
			foreach ($choice as $unit) {
				if ( $unit == $select ) {
					echo "<option selected>$unit</option>\n";
				}
				else {
					echo "<option>$unit</option>\n";
				}
			}
		?>
		</select>
		<br />
		Order
		<select name="nktagcloud_order">
		<?php
			$choice = array('ASC', 'DESC', 'RAND');
			$select = get_option('nktagcloud_order'); 
			foreach ($choice as $unit) {
				if ( $unit == $select ) {
					echo "<option selected>$unit</option>\n";
				}
				else {
					echo "<option>$unit</option>\n";
				}
			}
		?>
		</select>
		<br />
		Orderby
		<select name="nktagcloud_orderby">
		<?php
			$select = get_option('nktagcloud_orderby'); 
			$choice = array('name', 'count');
			foreach ($choice as $unit) {
				if ( $unit == $select ) {
					echo "<option selected>$unit</option>\n";
				}
				else {
					echo "<option>$unit</option>\n";
				}
			}
		?>
		</select>
		<br />
		Remove link to widget website?
		<select name="nktagcloud_homelink">
		<?php
			$choice = array('No', 'Yes');
			$select = get_option('nktagcloud_homelink'); 
			foreach ($choice as $unit) {
				if ( $unit == $select ) {
					echo "<option selected>$unit</option>\n";
				}
				else {
					echo "<option>$unit</option>\n";
				}
			}
		?>
		</select>
		<br />
		<br />
		<input type="submit" value="Update settings" />
	</form>
	<?php
}

function nktagcloud_footer() { ?>
Tag cloud widget powered by <a href="http://www.nkuttler.de/nktagcloud/">nktagcloud</a>
<?php
}
?>
